const { loginStatus } = require("./utils/common");

App({
  onLaunch() {
    const TOKEN = wx.getStorageSync('token') == '' ? '' : 'Bearer ' + wx.getStorageSync('token')
    this.globalData.token = TOKEN
    this.globalData.userId = wx.getStorageSync('userId')
    loginStatus(TOKEN.length > 0)

    const updateManager = wx.getUpdateManager()
    updateManager.onCheckForUpdate(function (res) {
      // 请求完新版本信息的回调
      if (res.hasUpdate) {
        wx.showLoading({
          title: '升级中请稍后...',
        })
      }
    })

    updateManager.onUpdateReady(function () {
      wx.hideLoading()
      wx.showModal({
        title: '更新提示',
        content: '新版本已经准备好，请重启应用',
        showCancel: false,
        success: function(res){
          updateManager.applyUpdate()
        }
      })
      
    })
    updateManager.onUpdateFailed(function () {
      // 新版本下载失败
      wx.hideLoading()
      wx.showModal({
        title: '更新提示',
        content: '更新失败，请检查网络是否可用'
      })
    })
  },
  globalData:{
    token: '',
    cateId: 0,
    roleType: 0,
    userId: 0
  }
});
