const { loginStatus } = require("../utils/common")
const { ApiUpload } = require("./api")

const APPLICATION_JSON_UTF8_VALUE = "application/json;charset=UTF-8"
const APPLICATION_JSON_UTF8_FORM = 'application/x-www-form-urlencoded;charset=UTF-8'
const RESPONSE_OK = 200
const TOKEN_BEOVERDUE = 400
const BASE_TOKEN = 'eyJ0eXAiOiJKV1QiLCJhbGciOiJIUzI1NiJ9.eyJpYXQiOjE2NTg5MDY2NjEsInN1YiI6IntcInVzZXJJZFwiOjB9IiwiaXNzIjoib25zaXRlLXNlcnZpY2UtbWluaS1hcHAifQ.o8f8sa9CTyGjpg-Bw5Qqp80QckkudFzk6UKK97CagCk'

const app = getApp()


// const HOST = 'http://172.16.1.55:9261'

const HOST = 'https://mini-api.chengshijiangren.com'



function fun(url, type, data, otherType) {
  let TOKEN = app.globalData.token ? app.globalData.token : 'Bearer ' + BASE_TOKEN
  let promise = new Promise((resolve, reject) => {
    console.log('发起请求')
    wx.request({
      url: HOST + url,
      method: type,
      data: type == 'GET' ? data : JSON.stringify(data),
      header: {
        'content-type': otherType ? APPLICATION_JSON_UTF8_FORM : APPLICATION_JSON_UTF8_VALUE,
        'Authorization': TOKEN
      },
      success: function (res) {
        wx.hideLoading()
        console.log('==========================================================================')
        console.log('==    token：' + TOKEN)
        console.log('==    接口地址：' + url)
        console.log('==    接口参数：' + JSON.stringify(data))
        console.log('==    请求类型：' + type)
        console.log("==    接口状态：" + res.statusCode);
        console.log('==    请求结果：' + JSON.stringify(res.data))
        console.log('==========================================================================')
        wx.stopPullDownRefresh();
        if (res.statusCode == RESPONSE_OK && res.data.code == RESPONSE_OK) {
          resolve(res.data)
        } else {
          if(res.data.code == 401){
            loginStatus(false)
            app.globalData.token = ""
            wx.removeStorageSync('token')
          }
          wx.showToast({
            title: res.data.msg,
            icon: 'none',
            duration: 2000
          })
          reject()
        }
      },
      fail: function (res) {
        wx.hideLoading()
        wx.stopPullDownRefresh();
        reject(res)
        //服务器连接异常
        console.log('==========================================================================')
        console.log('==    接口地址：' + url)
        console.log('==    接口参数：' + JSON.stringify(data))
        console.log('==    请求类型：' + type)
        console.log("==    服务器连接异常")
        console.log('==========================================================================')
      }
    })
  })
  return promise
}

module.exports = {
  wxGet: function (url, data) {
    return fun(url, 'GET', data)
  },
  wxPost: function (url, data) {
    return fun(url, 'POST', data)
  },
  wxFormPost: function (url, data) {
    return fun(url, 'POST', data, 'formPost')
  },
  wxPut: function (url, data) {
    return fun(url, 'PUT', data)
  },
  wxDelete: function (url, data) {
    return fun(url, 'DELETE', data)
  },
  wxUpload: function (path,fileType) {
    let promise = new Promise((resolve, reject) => {
      wx.uploadFile({
        filePath: path,
        name: 'files',
        url: HOST + ApiUpload,
        header: {
          "Authorization": app.globalData.token
        },
        formData: {
          fileType: fileType
        },
        success:function(res){
          let data = JSON.parse(res.data)
          if (res.statusCode == RESPONSE_OK && data.code == RESPONSE_OK) {
            resolve(data)
          } else {
            wx.showToast({
              title: res.data.msg,
              icon: 'none',
              duration: 2000
            })
            reject(data)
          }
        },
        fail(){
          reject()
        }
      })
    })
    return promise
  },
  HOST
}