// pages/login/login.js
import api from '../../http/api'
import {
  wxPost
} from '../../http/network'
import { loginStatus } from '../../utils/common'

const app = getApp()

Page({

  /**
   * 页面的初始数据
   */
  data: {

  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    wx.login({
      timeout: 2000,
    })
  },

  getUserInfo(e) {
    let that = this
    wx.showLoading({
      title: '授权中'
    })
    wx.getUserProfile({
      desc: 'desc',
      success(e) {
        wx.hideLoading()
        that.loginAction(e)
      },
      fail(e) {
        wx.hideLoading()
        console.log(e)
      }
    })
  },
  loginAction(data) {
    let that = this
    wx.login({
      timeout: 3000,
      success(e) {
        data['code'] = e.code
        that.getAuth(data)
      }
    })
  },
  getAuth(data) {
    wx.showLoading({
      title: '登录中'
    })

    const recommendUserId = wx.getStorageSync('recommendUserId')
    if(recommendUserId){
      data.shareUserId = recommendUserId
    }



    wxPost(api.ApiAuth, data).then((res) => {
      wx.hideLoading()
      app.globalData.token = res.data.token
      app.globalData.userId = res.data.userId
      wx.setStorageSync('token', res.data.token)
      wx.setStorageSync('userId', res.data.userId)
      app.globalData.roleType = res.data.roleType
      loginStatus(true)
      wx.showToast({
        icon: 'none',
        title: res.msg,
        success(){
          wx.navigateBack()
        }
      })
    }).catch(()=>{
      wx.hideLoading()
    })
  }
})