const { ApiOrderList, ApiOrderPay,ApiOrderCancel,ApiFinishOrder } = require("../../http/api")
const { wxPost, wxGet } = require("../../http/network")
const { showToast } = require("../../utils/common")

// pages/order/order-list.js
var page = 1

Page({

  /**
   * 页面的初始数据
   */
  data: {
    orderStatus: 0,
    triggered: false,
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad(options) {
    page = 1
    let orderStatus = options.orderStatus
    this.setData({
      orderStatus
    })
    this.getData(true)
  },
  bindscrolltolower(e){
    if(!this.canLoadMore)return
    if (this._freshing) return
    this._freshing = true
    this.getData(false)
  },
  statusChange(e){
    let index = e.currentTarget.dataset.index
    this.setData({
      orderStatus: index,
      list: null
    })
    this.getData(true)
  },
  getData(refresh){
    if (refresh) {
      page = 1
    }else{
      page+=1
    }
    let that = this
    wxPost(ApiOrderList, {
      "page": page,
      "orderStatus": this.data.orderStatus
    }).then(res => {
      var list = this.data.list
      if (refresh) {
        list = res.data.list
      } else {
        list = list.concat(res.data.list)
      }
      this.setData({
        list
      })
      this.canLoadMore = res.data.hasNextPage
    }).catch(()=>{

    }).finally(()=>{
      that.setData({
        triggered: false,
      })
      that._freshing = false
    })
  },

  onPulling(e) {
    console.log('onPulling:', e)
  },
  onRefresh() {
    if (this._freshing) return
    this._freshing = true
    this.setData({
      triggered: true,
    })
    this.getData(true)
  },
  onRestore(e) {
    console.log('onRestore:', e)
  },
  onAbort(e) {
    console.log('onAbort', e)
  },
  itemClickAction(e){
    let id = e.currentTarget.dataset.id
    wx.navigateTo({
      url: './order-detail?id='+id,
    })
  },
  cancelAction(e) {
    let id = e.detail.orderId
    let that = this
    wx.showModal({
      title: "温馨提示",
      content: "确认取消订单？",
      cancelColor: "#3E3E3E",
      confirmColor: "#437CFD",
      success(e) {
        if (e.confirm) {
          that.cancelWork(id)
        }
      }
    })
  },
  cancelWork(id){
    wxPost(ApiOrderCancel,{"id":id}).then(res=>{
      showToast("取消成功")
      this.getData(true)
    })
  },
  payAction(e){
    let orderId = e.detail.orderId
    wx.showLoading({
      title: '请求中',
    })
    wxGet(ApiOrderPay + orderId).then(res=>{
      wx.hideLoading()
      this.payWork(res.data.payParam)
    })
  },
  payWork(payParam){
    let that = this
    wx.requestPayment({
      nonceStr: payParam.nonceStr,
      package: payParam.package,
      paySign: payParam.paySign,
      signType: payParam.signType,
      timeStamp: payParam.timeStamp,
      success(e){
        that.getData(true)
      },
      fail(e){
      }
    })
  },
  serviceAction(){
    wx.switchTab({
      url: '/pages/service/service',
    })
  },
  finishAction(e){
    let id = e.detail.orderId
    let that = this
    wx.showModal({
      title: "温馨提示",
      content: "确认完成该订单？",
      cancelColor: "#3E3E3E",
      confirmColor: "#437CFD",
      success(e) {
        if (e.confirm) {
          that.finishWork(id)
        }
      }
    })
  },
  finishWork(id){
    wx.showLoading({
      title: '请求中',
    })
    wxPost(ApiFinishOrder,{"id":id}).then(res=>{
      wx.hideLoading()
      showToast("操作成功")
      this.getData(true)
    })
  }
})