const { ApiOrderValuator, ApiRevaluator } = require("../../http/api")
const { wxPost } = require("../../http/network")
const { showToast } = require("../../utils/common")

// pages/process/choose.js
Page({

  /**
   * 页面的初始数据
   */
  data: {
    valuator: null,
    expectArrivalTime: null,
    remark: ""
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad(options) {
    this.picker = this.selectComponent("#picker")
    this.id = options.id
    this.fix = options.fix
  },
  chooseAction(){
    let that = this
    wx.navigateTo({
      url: './user-list?type=1',
      events:{
        infoBack:function(e){
          that.setData({
            valuator: e
          })
        }
      }
    })
  },
  chooseTime(){
    this.picker.showDialog();
  },
  confirm(e) {
    this.setData({
      expectArrivalTime: e.detail.selectDate
    })
  },
  remarkInput(e){
    this.setData({
      remark: e.detail.value
    })
  },
  submitAction(){
    if(this.data.valuator == null){
      showToast("请选择估价员")
      return
    }
    if(this.data.expectArrivalTime == null){
      showToast("请选择上门时间")
      return
    }
    let that = this
    let date = this.data.expectArrivalTime
    let url = ApiOrderValuator
    if(this.fix){
      url = ApiRevaluator
    }
    wxPost(url,{
      expectArrivalTime: date,
      hostId: this.data.valuator.id,
      id: this.id,
      remark: this.data.remark
    }).then(res=>{
      wx.showToast({
        icon: 'none',
        title: '提交成功',
        success(){
          let eventChannel = that.getOpenerEventChannel()
          eventChannel.emit("updateData")
          wx.navigateBack()
        }
      })
    })
  }
})