const { ApiValuator, ApiWorker } = require("../../http/api")

const { wxGet } = require("../../http/network")
const { showToast } = require("../../utils/common")

// pages/process/user-list.js
Page({

  /**
   * 页面的初始数据
   */
  data: {
    name: "",
    list: [],
    selected: -1
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad(options) {
    //1 估价  2派单
    this.type = options.type
    if(this.type == 1){
      wx.setNavigationBarTitle({
        title: '选择估价员',
      })
      this.getValuatorList()
    }
    if(this.type == 2){
      wx.setNavigationBarTitle({
        title: '选择维修员',
      })
      this.getWorkList()
    }
  },
  getValuatorList(){
    wxGet(ApiValuator,{name:this.data.name}).then(res=>{
      this.setData({
        list: res.data
      })
    })
  },
  getWorkList(){
    wxGet(ApiWorker,{name:this.data.name}).then(res=>{
      this.setData({
        list: res.data
      })
    })
  },
  chooseAction(e){
    let index = e.currentTarget.dataset.index
    this.setData({
      selected: index
    })
  },
  submitAction(){
    if(this.data.selected == -1){
      if(this.type == 1){
        showToast("请选择估价员")
      }
      if(this.type == 2){
        showToast("请选择维修员")
      }
      return
    }
    let info = this.data.list[this.data.selected]
    let eventChannel = this.getOpenerEventChannel()
    eventChannel.emit("infoBack",info)
    wx.navigateBack()
  },
  nameInputChange(e){
    this.getValuatorList()
  }
})