const {
  ApiManagerOrderList, ApiOrderCancel, ApiFinishOrder, ApiOrderNum, ApiSendOrder
} = require("../../http/api")
const {
  wxPost, wxGet
} = require("../../http/network")
const { showToast } = require("../../utils/common")

var page = 1

const app = getApp()

Page({

  /**
   * 页面的初始数据
   */
  data: {
    orderStatus: 0,
    triggered: false,
    date: null,
    keyWord: '',
    roleType: 0,
    orderNum1:0,
    orderNum3:0,
    orderNum4:0,
    price: null,
    overlayVisible: false
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad(options) {
    page = 1
    this.setData({
      roleType: app.globalData.roleType
    })
    this.getData(true)
  },
  bindscrolltolower(e) {
    if(!this.canLoadMore)return
    if (this._freshing) return
    this._freshing = true
    this.getData(false)
  },
  statusChange(e) {
    let index = e.currentTarget.dataset.index
    this.setData({
      orderStatus: index,
      list: null
    })
    this.getData(true)
  },
  getData(refresh) {
    if (refresh) {
      page = 1
      this.getOrderNum()
    }else{
      page += 1
    }
    let that = this
    wxPost(ApiManagerOrderList, {
      "page": page,
      "orderStatus": this.data.orderStatus,
      "keyWord": this.data.keyWord,
      "month": this.data.date,
      "size": 10
    }).then(res => {
      var list = this.data.list
      if (refresh) {
        list = res.data.list
      } else {
        list = list.concat(res.data.list)
      }
      this.setData({
        list
      })
      this.canLoadMore = res.data.hasNextPage
    }).catch(() => {

    }).finally(() => {
      that.setData({
        triggered: false,
      })
      that._freshing = false
    })
  },
  onPulling(e) {
    console.log('onPulling:', e)
  },
  onRefresh() {
    console.log("onRefresh")
    if (this._freshing) return
    this._freshing = true
    this.setData({
      triggered: true,
    })
    this.getData(true)
  },
  onRestore(e) {
    console.log('onRestore:', e)
  },
  onAbort(e) {
    console.log('onAbort', e)
  },
  itemClickAction(e) {
    let id = e.currentTarget.dataset.id
    let that = this
    wx.navigateTo({
      url: '../order/order-detail?admin=1&id=' + id,
      events: {
        updateData: function (e) {
          that.getData(true)
        }
      }
    })
  },
  dateChange(e) {
    let date = e.detail.value
    this.setData({
      date
    })
    this.getData(true)
  },
  keywordChange(e) {
    this.getData(true)
  },
  dealAction(e) {
    let id = e.detail.id
    let that = this
    wx.navigateTo({
      url: '../order/order-detail?admin=1&id=' + id,
      events: {
        updateData: function (e) {
          that.getData(true)
        }
      }
    })
  },
  cancelAction(e) {
    let id = e.detail.id
    let that = this
    wx.showModal({
      title: "温馨提示",
      content: "确认取消订单？",
      cancelColor: "#3E3E3E",
      confirmColor: "#437CFD",
      success(e) {
        if (e.confirm) {
          that.cancelWork(id)
        }
      }
    })
  },
  cancelWork(id){
    wxPost(ApiOrderCancel,{"id":id}).then(res=>{
      showToast("取消成功")
      this.getData(true)
    })
  },
  finishAction(e){
    let id = e.detail.id
    let that = this
    wx.showModal({
      title: "温馨提示",
      content: "确认完成该订单？",
      cancelColor: "#3E3E3E",
      confirmColor: "#437CFD",
      success(e) {
        if (e.confirm) {
          that.finishWork(id)
        }
      }
    })
  },
  finishWork(id){
    wx.showLoading({
      title: '请求中',
    })
    wxPost(ApiFinishOrder,{"id":id}).then(res=>{
      showToast("操作成功")
      this.getData(true)
    })
  },
  dispatchAction(e){
    let id = e.detail.id
    let that = this
    wx.navigateTo({
      url: '/pages/process/dispatch?id=' + id,
      events: {
        updateData: function (e) {
          that.getData(true)
        }
      }
    })
  },
  getOrderNum(){
    wxGet(ApiOrderNum).then(res=>{
      this.setData({
        orderNum1: res.data["1"],
        orderNum3: res.data["3"],
        orderNum4: res.data["4"]
      })
    })
  },
  fixDispatchAction(e){
    let id = e.detail.id
    let that = this
    wx.navigateTo({
      url: '/pages/process/dispatch?fix=1&id=' + id,
      events: {
        updateData: function (e) {
          that.getData(true)
        }
      }
    })
  },
  sendOrderAction(e){
    this.id = e.detail.id
    this.setData({
      overlayVisible: true
    })
  },
  cancelOverlay() {
    this.setData({
      overlayVisible: false
    })
  },
  overlayAction() {
    if (!this.data.price) {
      showToast("请输入金额")
      return
    }
    let that = this
    wx.showLoading({
      title: '请求中',
    })
    wxPost(ApiSendOrder, {
      "id": this.id,
      "price": this.data.price
    }).then(res => {
      showToast("发送成功")
      that.setData({
        overlayVisible: false
      })
      that.getData(true)
    })
  }
})